#!/usr/local/bin/perl

#
# JOYFUL NOTE : regist.cgi - 2012/03/07
# Copyright (c) KentWeb
# http://www.kent-web.com/
#

# ⥸塼
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use CGI::Minimal;
use Jcode;

# եǧ
require "./init.cgi";
my %cf = &init;

# ǡ
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
&error('̥С') if ($cgi->truncated);
my %in = &parse_form($cgi);

if ($in{mode} eq "regist") { &regist; }
if ($in{mode} eq "log_edit") { &log_edit; }
if ($in{mode} eq "log_dele") { &log_dele; }
&error("ʽǤ");

#-----------------------------------------------------------
#  Ƶ
#-----------------------------------------------------------
sub regist {
	# եϥå
	&form_check;

	# ƥå
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		if ($in{captcha} !~ /^\d{$cf{cap_len}}$/) {
			&error("ƥǤ<br>ƥեäƺɹ߸塢ϤƤ");
		}

		# ƥå
		# -1 : ԰
		#  0 : »֥С
		#  1 : 
		my $chk = cap::check($in{captcha}, $in{str_crypt}, $cf{captcha_key}, $cf{cap_time}, $cf{cap_len});
		if ($chk == 0) {
			&error("ƥ»֤Ķᤷޤ<br>ƥեäƺɹ߸塢οϤƤ");
		} elsif ($chk == -1) {
			&error("ƥǤ<br>ƥեäƺɹ߸塢ϤƤ");
		}
	}

	# Ѵ
	Jcode::convert(\$in{name}, 'euc');
	Jcode::convert(\$in{sub}, 'euc');
	Jcode::convert(\$in{comment}, 'euc');

	# ۥȼ
	my ($host,$addr) = &get_host;

	# ּ
	my ($date,$time) = &get_time;

	# 򳫤
	my @data;
	open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	my $top = <DAT>;

	# NO
	my ($no, $ip, $time2) = split(/<>/, $top);
	$no++;

	# Ϣ³ƥå
	if ($addr eq $ip && $cf{wait} > $time - $time2) {
		close(DAT);
		&error("Ϣ³ƤϤ⤦Ф餯֤򤪤Ʋ");
	}

	# åץ
	my ($ext,$w,$h);
	if ($in{upfile}) {
		($ext,$w,$h) = &upload($no);
	}

	# Ź沽
	my $crypt = &encrypt($in{pwd}) if ($in{pwd} ne "");

	# Ƶξ
	my @past;
	if ($in{reno} eq "") {
		my ($i,$stop);
		while (<DAT>) {
			my ($no2,$reno2,$dat,$nam,$eml,$sub,$com,$url,$hos,$pw,$col,$ex2,$w2,$h2,$chk) = split(/<>/);
			if ($reno2 eq "") { $i++; }
			if ($i > $cf{max} - 1 && $reno2 eq "") { $stop = 1; }
			if (!$stop) {
				push(@data,$_);
			} else {
				# 
				if ($cf{pastkey}) { push(@past,$_); }

				# źեե
				if ($ex2) { unlink("$cf{imgdir}/$no2$ex2"); }
			}
		}
		unshift(@data,"$no<><>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$crypt<>$in{color}<>$ext<>$w<>$h<>0<>\n");
		unshift(@data,"$no<>$addr<>$time<>\n");

		# 
		if (@past > 0) { &make_past(@past); }

	# 쥹ȥåץȤ
	} elsif ($in{reno} && $cf{topsort}) {

		my ($flg,$match,@tmp);
		while (<DAT>) {
			my ($no2,$reno2,$dat,$nam,$eml,$sub,$com,$url,$hos,$pw,$col,$ex2,$w2,$h2,$chk) = split(/<>/);

			# Ƶ
			if ($in{reno} == $no2) {
				if ($reno2) { $flg = 1; last; }
				$match = 1;
				push(@data,$_);

			# 쥹
			} elsif ($in{reno} == $reno2) {
				push(@data,$_);

			# Ƶľ֤
			} elsif ($match == 1 && $in{reno} != $reno2) {
				$match = 2;
				push(@data,"$no<>$in{reno}<>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$crypt<>$in{color}<>$ext<>$w<>$h<>0<>\n");
				push(@tmp,$_);

			} else {
				push(@tmp,$_);
			}
		}
		if ($flg || !$match) {
			close(DAT);
			&error("ֿ׵Ǥ");
		}

		# ǽΥ쥹Υ
		if ($match == 1) {
			push(@data,"$no<>$in{reno}<>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$crypt<>$in{color}<>$ext<>$w<>$h<>0<>\n");
		}
		# 쥹ȥåפ
		push(@data,@tmp);
		unshift(@data,"$no<>$addr<>$time<>\n");

	# 쥹ȥåץȤʤ
	} else {

		my ($flg,$match);
		while (<DAT>) {
			my ($no2,$reno2,$dat,$nam,$eml,$sub,$com,$url,$hos,$pw,$col,$ex2,$w2,$h2,$chk) = split(/<>/);

			if ($match == 0 && $in{reno} == $no2) {
				if ($reno2) { $flg = 1; last; }
				$match = 1;

			} elsif ($match == 1 && $in{reno} != $reno2) {
				$match = 2;
				push(@data,"$no<>$in{reno}<>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$crypt<>$in{color}<>$ext<>$w<>$h<>0<>\n");
			}
			push(@data,$_);
		}
		if ($flg || !$match) {
			close(DAT);
			&error("ֿ׵Ǥ");
		}

		if ($match == 1) {
			push(@data,"$no<>$in{reno}<>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$crypt<>$in{color}<>$ext<>$w<>$h<>0<>\n");
		}
		unshift(@data,"$no<>$addr<>$time<>\n");
	}

	# 
	seek(DAT, 0, 0);
	print DAT @data;
	truncate(DAT, tell(DAT));
	close(DAT);

	# åǼ
	&set_cookie($in{name},$in{email},$in{url},$in{color});

	# ᡼
	if ($cf{mailing} == 1) {
		my $clip = "$no$ext" if ($ext);
		&mail_to($date,$host,$clip);
	}

	# λ
	&message("꤬Ȥޤޤ");
}

#-----------------------------------------------------------
#  桼
#-----------------------------------------------------------
sub log_dele {
	if ($in{no} eq '' || $in{pwd} eq '') {
		&error("NoޤϺϥǤ");
	}

	my ($top,$flg,$oya_flg,@data);
	open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	my $top = <DAT>;
	while (<DAT>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ext,$w,$h,$chk) = split(/<>/);

		# 
		if ($in{no} == $no) {
			$oya_flg = 1;
			$flg = 1;
			if ($pw eq '') {
				$flg = 2;
				last;
			}
			# ȹ
			if (&decrypt($in{pwd},$pw) != 1) {
				$flg = 3;
				last;
			}
			# źեե
			if ($ext) { unlink("$cf{imgdir}/$no$ext"); }
			next;

		# Ƶϥ쥹
		} elsif ($oya_flg && $in{no} == $reno) {

			# źեե
			if ($ext) { unlink("$cf{imgdir}/$no$ext"); }
			next;
		}
		push(@data,$_);
	}
	if (!$flg) {
		close(DAT);
		&error("ޤ");
	} elsif ($flg == 2) {
		close(DAT);
		&error("ˤϺꤵƤޤ");
	} elsif ($flg == 3) {
		close(DAT);
		&error("㤤ޤ");
	}

	# 
	seek(DAT, 0, 0);
	print DAT $top;
	print DAT @data;
	truncate(DAT, tell(DAT));
	close(DAT);

	# λ
	&message("ޤ");
}

#-----------------------------------------------------------
#  
#-----------------------------------------------------------
sub log_edit {
	if ($in{no} eq '' || $in{pwd} eq '') {
		&error("NoޤϰžڥϥǤ");
	}

	# ¹
	if ($in{job} eq "edit") {

		# եϥå
		&form_check;

		# Ѵ
		Jcode::convert(\$in{name}, 'euc');
		Jcode::convert(\$in{sub}, 'euc');
		Jcode::convert(\$in{comment}, 'euc');

		my ($flg,$ext2,$w2,$h2,@data);
		open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ext,$w,$h,$chk) = split(/<>/);

			if ($in{no} == $no) {
				$flg = 1;
				if ($pw eq '') {
					$flg = -1;
					last;
				}
				# ȹ
				if (&decrypt($in{pwd},$pw) != 1) {
					$flg = -2;
					last;
				}

				# åץ
				if ($in{upfile}) {
					($ext2,$w2,$h2) = &upload($in{no});
				}

				# 
				if ($in{imgdel}) {
					unlink("$cf{imgdir}/$in{no}$ext");
					$ext = $w = $h = '';
				}

				# źեåץɤξ
				if ($ext2) {
					# ĥѹξե
					if ($ext && $ext2 ne $ext) {
						unlink("$cf{imgdir}/$in{no}$ext");
					}
					# źեե
					($ext,$w,$h) = ($ext2,$w2,$h2);
				}
				$_ = "$no<>$reno<>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$pw<>$in{color}<>$ext<>$w<>$h<>0<>\n";
			}
			push(@data,$_);
		}

		# 
		seek(DAT, 0, 0);
		print DAT $top;
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		if ($flg < 1) { &error("ʽǤ"); }

		# λå
		&message("λޤ");
	}

	my ($flg,$log);
	open(IN,"$cf{logfile}") or &error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ext,$w,$h,$chk) = split(/<>/);

		if ($in{no} == $no) {
#			if ($reno) { $resmd = 1; }

			$flg = 1;
			if ($pw eq '') {
				$flg = -1;
			}
			# ȹ
			if (&decrypt($in{pwd},$pw) != 1) {
				$flg = -2;
			}
			$log = $_;
			last;
		}
	}
	close(IN);

	# Ƚ
	if (!$flg) {
		&error("ޤ");
	} elsif ($flg == -1) {
		&error("ˤϺꤵƤޤ");
	} elsif ($flg == -2) {
		&error("㤤ޤ");
	}

	# 
	my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ext,$w,$h,$chk) = split(/<>/, $log);
	$com =~ s/<br>/\n/g;
	$url ||= 'http://';

	# ܥ
	my @col = split(/\s+/, $cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $col) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]"></span>\n|;
	}

	# ե
	open(IN,"$cf{tmpldir}/edit.html") or &error("open err: edit.html");
	print "Content-type: text/html\n\n";
	while(<IN>) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!num!/$in{no}/g;
		s/!pwd!/$in{pwd}/g;
		s/!name!/$name/g;
		s/!email!/$eml/g;
		s/!sub!/$sub/g;
		s/!comment!/$com/g;
		s/!url!/$url/g;
		s/!color!/$color/g;

		print;
	}
	close(IN);
	exit;
}

#-----------------------------------------------------------
#  
#-----------------------------------------------------------
sub make_past {
	my @past = @_;

	# NOե
	open(NO,"+< $cf{nofile}") or &error("open err: $cf{nofile}");
	eval "flock(NO, 2);";
	my $num = <NO>;

	# 
	my $pastfile = "$cf{pastdir}/" . sprintf("%04d",$num) . ".cgi";

	# 򳫤
	open(LOG,"+< $pastfile") or &error("open err: $pastfile");
	eval "flock(LOG, 2);";
	my @data = <LOG>;

	# ԿСե
	if (@data > $cf{pastmax}) {

		# Ĥ
		@data = ();
		close(LOG);

		# NO
		seek(NO, 0, 0);
		print NO ++$num;
		truncate(NO, tell(NO));
		close(NO);

		$pastfile = "$cf{pastdir}/" . sprintf("%04d",$num) . ".cgi";

		open(LOG,"+> $pastfile");
		eval "flock(LOG, 2);";
		print LOG @past;
		close(LOG);

		chmod(0666, $pastfile);

	# 
	} else {

		# NOեĤ
		close(NO);

		# 
		seek(LOG, 0, 0);
		print LOG @past;
		print LOG @data;
		truncate(LOG, tell(LOG));
		close(LOG);
	}
}

#-----------------------------------------------------------
#  եϥå
#-----------------------------------------------------------
sub form_check {
	# ײԥå
	$in{sub}  =~ s/<br>//g;
	$in{name} =~ s/<br>//g;
	$in{pwd}  =~ s/<br>//g;
	$in{captcha} =~ s/<br>//g;
	$in{color} =~ s/<br>//g;
	$in{comment} =~ s/(<br>)+$//g;

	# å
	if ($cf{no_wd}) { &no_wd; }
	if ($cf{jp_wd}) { &jp_wd; }
	if ($cf{urlnum} > 0) { &urlnum; }

	# Ĵ
	if ($in{url} eq 'http://') { $in{url} = ''; }
	$in{sub} ||= "̵";

	# Ϲܥå
	my $err;
	if (length($in{sub}) > $cf{sub_len}*2) {
		$err .= "ȥ̾$cf{sub_len}ʸǤ<br>";
	}
	if ($in{name} eq "") { $err .= "̾ϤƤޤ<br>"; }
	if ($in{comment} eq "") { $err .= "ȤϤƤޤ<br>"; }
	if ($in{email} ne '' && $in{email} !~ /^[\w\.\-]+\@[\w\.\-]+\.[a-zA-Z]{2,}$/) {
		$err .= "ť᡼ƤǤ<br>";
	}
	if ($in{url} ne '' && $in{url} !~ /^https?:\/\/[\w-.!~*'();\/?:\@&=+\$,%#]+$/) {
		$err .= "URLǤ<br>";
	}
	&error($err) if ($err);
}

#-----------------------------------------------------------
#  ᡼
#-----------------------------------------------------------
sub mail_to {
	my ($date,$host,$clip) = @_;

	# ᡼륿ȥ
	my $msub = Jcode->new("BBS : $in{sub}")->mime_encode;

	# β
	my $com = $in{comment};
	$com =~ s/<br>/\n/g;
	$com =~ s/&lt;/>/g;
	$com =~ s/&gt;/</g;
	$com =~ s/&quot;/"/g;
	$com =~ s/&amp;/&/g;
	$com =~ s/&#39;/'/g;

	# ᡼ʸ
	my $mbody = <<"EOM";
ǼĤƤޤ

$date
ۥȡ$host

̾  $in{sub}
̾$in{name}
E-mail$in{email}
URL   $in{url}
ź  $clip

$com
EOM

	# JISѴ
	Jcode::convert(\$mbody, 'jis', 'euc');

	# ᡼륢ɥ쥹ʤϴԥ᡼֤
	$in{email} ||= $cf{mailto};

	# sendmailޥ
	my $scmd = "$cf{sendmail} -t -i";
	if ($cf{sendm_f}) {
		$scmd .= " -f $in{email}";
	}

	# 
	open(MAIL,"| $scmd") or &error("");
	print MAIL "To: $cf{mailto}\n";
	print MAIL "From: $in{email}\n";
	print MAIL "Subject: $msub\n";
	print MAIL "MIME-Version: 1.0\n";
	print MAIL "Content-type: text/plain; charset=ISO-2022-JP\n";
	print MAIL "Content-Transfer-Encoding: 7bit\n";
	print MAIL "X-Mailer: $cf{version}\n\n";
	print MAIL "$mbody\n";
	close(MAIL);
}

#-----------------------------------------------------------
#  ּ
#-----------------------------------------------------------
sub get_time {
	$ENV{TZ} = "JST-9";
	my $time = time;
	my ($min,$hour,$mday,$mon,$year,$wday) = (localtime($time))[1..6];
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# Υեޥå
	my $date = sprintf("%04d/%02d/%02d(%s) %02d:%02d",
			$year+1900,$mon+1,$mday,$week[$wday],$hour,$min);

	return ($date, $time);
}

#-----------------------------------------------------------
#  ػߥɥå
#-----------------------------------------------------------
sub no_wd {
	my $flg;
	foreach ( split(/,/, $cf{no_wd}) ) {
		if (index("$in{name} $in{sub} $in{comment}", $_) >= 0) {
			$flg = 1;
			last;
		}
	}
	if ($flg) { &error("ػߥɤޤޤƤޤ"); }
}

#-----------------------------------------------------------
#  ܸå
#-----------------------------------------------------------
sub jp_wd {
	if ($in{comment} !~ /[\x81-\x9F\xE0-\xFC][\x40-\x7E\x80-\xFC]/) {
		&error("åܸ줬ޤޤƤޤ");
	}
}

#-----------------------------------------------------------
#  URLĿå
#-----------------------------------------------------------
sub urlnum {
	my $com = $in{comment};
	my ($num) = ($com =~ s|(https?://)|$1|ig);
	if ($num > $cf{urlnum}) {
		&error("URLɥ쥹Ϻ$cf{urlnum}ĤޤǤǤ");
	}
}

#-----------------------------------------------------------
#  ۥ̾
#-----------------------------------------------------------
sub get_host {
	# IP&ۥȼ
	my $host = $ENV{REMOTE_HOST};
	my $addr = $ENV{REMOTE_ADDR};

	if ($cf{gethostbyaddr} && ($host eq "" || $host eq $addr)) {
		$host = gethostbyaddr(pack("C4", split(/\./, $addr)), 2);
	}

	# IPå
	my $flg;
	foreach ( split(/\s+/, $cf{deny_addr}) ) {
		s/\./\\\./g;
		s/\*/\.\*/g;

		if ($addr =~ /^$_/i) { $flg = 1; last; }
	}
	if ($flg) {
		&error("ĤƤޤ");

	# ۥȥå
	} elsif ($host) {

		foreach ( split(/\s+/, $cf{deny_host}) ) {
			s/\./\\\./g;
			s/\*/\.\*/g;

			if ($host =~ /$_$/i) { $flg = 1; last; }
		}
		if ($flg) {
			&error("ĤƤޤ");
		}
	}
	$host ||= $addr;
	return ($host, $addr);
}

#-----------------------------------------------------------
#  cryptŹ
#-----------------------------------------------------------
sub encrypt {
	my $in = shift;

	my @wd = ('a'..'z', 'A'..'Z', '0'..'9', '.', '/');
	srand;
	my $salt = $wd[int(rand(@wd))] . $wd[int(rand(@wd))];
	crypt($in, $salt) || crypt ($in, '$1$' . $salt);
}

#-----------------------------------------------------------
#  cryptȹ
#-----------------------------------------------------------
sub decrypt {
	my ($in, $dec) = @_;

	my $salt = $dec =~ /^\$1\$(.*)\$/ ? $1 : substr($dec, 0, 2);
	if (crypt($in, $salt) eq $dec || crypt($in, '$1$' . $salt) eq $dec) {
		return 1;
	} else {
		return 0;
	}
}

#-----------------------------------------------------------
#  λå
#-----------------------------------------------------------
sub message {
	my ($msg) = @_;

	open(IN,"$cf{tmpldir}/message.html") or &error("open err: message.html");
	print "Content-type: text/html\n\n";
	while(<IN>) {
		s/!bbs_cgi!/$cf{bbs_cgi}/g;
		s/!message!/$msg/g;

		print;
	}
	close(IN);
	exit;
}

#-----------------------------------------------------------
#  åȯ
#-----------------------------------------------------------
sub set_cookie {
	my @data = @_;

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef) = gmtime(time + 60*24*60*60);
	my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# եޥå
	my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
				$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec);

	# URL󥳡
	my $cook;
	foreach (@data) {
		s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
		$cook .= "$_<>";
	}

	print "Set-Cookie: $cf{cookie_id}=$cook; expires=$gmt\n";
}

#-----------------------------------------------------------
#  źեåץ
#-----------------------------------------------------------
sub upload {
	my $num = shift;

	# ĥҼ
	my $ex = $cgi->param_filename('upfile') =~ /(\.[^\\\/:\.]+)$/ ? $1 : &error("ĥ");
	$ex =~ tr/A-Z/a-z/;
	if ($ex eq '.jpeg') { $ex = '.jpg'; }

	# ĥҥå
	my %ex;
	foreach ( split(/,/, $cf{extension}) ) {
		$ex{".$_"}++;
	}
	if (!defined($ex{$ex})) { &error("ĤʤĥҤǤ  $ex"); }

	# źեե
	my $upfile = "$cf{imgdir}/$num$ex";

	# åץɽ񤭹
	my $buf;
	open(UP,"+> $upfile") or &error("up err: $upfile");
	binmode(UP);
	print UP $in{upfile};
	close(UP);

	chmod(0666,$upfile);

	# 
	my ($w,$h);
	if ($ex eq ".jpg") { ($w,$h) = &j_size($upfile); }
	elsif ($ex eq ".gif") { ($w,$h) = &g_size($upfile); }
	elsif ($ex eq ".png") { ($w,$h) = &p_size($upfile); }

	return ($ex,$w,$h);
}

#-----------------------------------------------------------
#  JPEGǧ
#-----------------------------------------------------------
sub j_size {
	my $jpg = shift;

	my ($h, $w, $t);
	open(IMG,"$jpg");
	binmode(IMG);
	read(IMG, $t, 2);
	while (1) {
		read(IMG, $t, 4);
		my ($m, $c, $l) = unpack("a a n", $t);

		if ($m ne "\xFF") {
			$w = $h = 0;
			last;
		} elsif ((ord($c) >= 0xC0) && (ord($c) <= 0xC3)) {
			read(IMG, $t, 5);
			($h, $w) = unpack("xnn", $t);
			last;
		} else {
			read(IMG, $t, ($l - 2));
		}
	}
	close(IMG);

	return ($w, $h);
}

#-----------------------------------------------------------
#  GIFǧ
#-----------------------------------------------------------
sub g_size {
	my $gif = shift;

	my $data;
	open(IMG,"$gif");
	binmode(IMG);
	sysread(IMG, $data, 10);
	close(IMG);

	if ($data =~ /^GIF/) { $data = substr($data, -4); }
	my $w = unpack("v", substr($data, 0, 2));
	my $h = unpack("v", substr($data, 2, 2));

	return ($w, $h);
}

#-----------------------------------------------------------
#  PNGǧ
#-----------------------------------------------------------
sub p_size {
	my $png = shift;

	my $data;
	open(IMG,"$png");
	binmode(IMG);
	read(IMG, $data, 24);
	close(IMG);

	my $w = unpack("N", substr($data, 16, 20));
	my $h = unpack("N", substr($data, 20, 24));

	return ($w, $h);
}


1;

